import random

doors = [1, 2, 3]

carsWon = 0         # Running total.

games = 1000        # Games to play.

for n in range(games):

    carDoor = random.choice(doors)      # The car and (implied) goats are placed - with Monty's full knowledge.

    playerDoor = random.choice(doors)   # The player chooses a door at random.

    # Monty has to pick a door that's neither the player's or the car's.
    #
    # Sometimes he'll have a choice of two, and sometimes just one door to choose from.
    #
    montyDoor = random.choice(list(set(doors) - set([playerDoor, carDoor])))

    # The above COULD be broken down into discrete steps like this:
    #
    #   remainingDoors = set(doors) - set([playerDoor, carDoor])
    #
    #   remainingDoorsList = list(remainingDoors)
    #
    #   montyDoor = random.choice(remainingDoorsList)

    # This line implements the strategy in which the player swaps doors. Comment it out to have s/he stick.
    #
    # Now, there will always only be one door remaining when playerDoor and montyDoor are subracted from the
    # set of all doors.  Here, we'll just 'pop' that out of the resultant set.
    #
    #playerDoor = (set(doors) - set([playerDoor, montyDoor])).pop()

    # Alternative versions of the line above are:
    #
    #   # List with only one member - at index/subscript zero.
    #   #
    #   playerDoor = list(set(doors) - set([playerDoor, montyDoor]))[0]
    #
    #   # Same as above, but the single item is randomly chosen - um, from one item!
    #   #
    #   playerDoor = random.choice(list(set(doors) - set([playerDoor, montyDoor])))
    #

    if playerDoor == carDoor:

        carsWon = carsWon + 1

print('The player won the car', round(carsWon / (games / 100)), '%', 'of the time')

# A nicer version of the line above could be ...
#
#   print(f'The player won the car {round(carsWon / (games / 100))}% of the time')
#
# That uses an 'f string'.