""" coin stuff. """
import random

showToss = None

def toss():
    """ returns H or T """
    t = random.choice(['H', 'T'])

    # For checking that, for example, genSequenceOptimal works as
    # expected.
    #
    if showToss:
        print(t, end='')

    return t


def genSequence(seqToFind):
    """ Builds a string until a given sequence appears to the tail end """
    genSeq = ''
    while not genSeq.endswith(seqToFind):
        genSeq = genSeq + toss()
    return genSeq


def genSequenceOptimal(seqToFind):
    """ Optimal sequence finder (ish)"""
    tosses = 0
    genSeq = ''
    n = len(seqToFind)
    while len(genSeq) < n:
        genSeq += toss()
    tosses += n
    while genSeq != seqToFind:
        # Use slicing to remove the first toss in genSeq,
        # and then add a new toss to the end.
        genSeq = genSeq[1:] + toss()
        tosses += 1
    # No point in returning genSeq as it will be identical to seqToFind
    # at this point. Just return the total tosses made.
    return tosses


def sequence(n):
    """ returns n coins tosses """
    s = ''
    for _ in range(n):
        s += toss()
    return s

